/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WTIMER_H
#define WTIMER_H

#include "fwk.h"
#include "wTimes.h"

namespace fwk
{

/**
 * @brief Un simple chronometre
 */

class FWK_API Timer
{
    Times tStart;
    Times tElaps;

    bool isOn;

public:
    Timer();

    void start();
    void stop();
    void reset();
    Times read() const;

    friend FWK_API std::ostream &operator<<(std::ostream &out, Timer const &obj);

#ifndef SWIG
    void setTStart(Times times)
    {
        tStart = times;
    };
    void setTElaps(Times times) { tElaps = times; };
#endif
};
};     // namespace fwk
#endif // TIMER_H
